Subject: Re: git difftool does does not respect current working directory

From: David Aguilar <[email-masked]>
Date: Thu, 19 May 2011 21:10:46 -0700

On Thu, May 19, 2011 at 08:59:00PM -0700, David Aguilar wrote:
> 
> Hello,
> 
> On Sun, May 15, 2011 at 10:39:18PM -0700, Junio C Hamano wrote:
> > Frédéric Heitzmann  <[email-masked]> writes:
> > 
> > > Unfortunately, 'git difftool' does not keep the current working directory while
> > > launching gvimdiff.
> > >
> > > => Is it done on purpose ?
> > > If not, it is probably a good idea to fix this.
> > 
> > [...snip...]
> > 
> > If the answers to both of them are No, then it might be a good idea to
> > change the behaviour.
> 
> Another thing to consider is ensuring that there is a
> consistency between 'diff' and 'difftool'.
> 
> When you run 'git diff' from a subdirectory git will show you
> a diff against the entire tree.  In this respect, 'difftool' is
> consistent.  In that sense, yes, this is very much "on purpose".
> 
> [...snip...]

I just realized that I was focusing on the "whole tree diff"
aspect which really is orthogonal to the "chdir to root"
done by 'git diff' when running $GIT_EXTERNAL_DIFF scripts.

I imagine you want to be able to use vimdiff while diffing
and open files, etc., from the current directory?

In that case, maybe we can have the best of both worlds --
whole-tree diff and keeping the current directory.
That would be kinda like what 'git status' does when it shows
you relative paths above and beside the current directory.

We would have to change the way $GIT_EXTERNAL_DIFF works so
that it preserves the current directory and constructs
paths relative to it.  Patches welcome :-)

I don't really know whether it would be a good thing to do,
though, since I have not dug too deep into how the extdiff
code is structured.
-- 
					David